/*
  SerialDLF.cpp - Arduino Library
  Copyright (c) 2013 Denis LE FUR.  All right reserved.

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include "Arduino.h"
#include "SerialDLF.h"

//-------------------------------------------------
// Classe SerialString
//------------------------------------------------- 
SerialString::SerialString()
{
  _message = "";
  _keyword= "";
}

//-------------------------------------------------
// renew()
//-------------------------------------------------
/*
read the new message on the serial.
*/  
void SerialString::renew()
{
  _message="";
  char caractere;
  if (Serial.available() > 0)
  { 
    delay(100);
    int numChar=Serial.available();
    while (numChar > 0)
    {
      caractere=Serial.read();
      _message=_message+caractere;
      numChar=numChar-1;
    }
    //_message.toLowerCase();
    if (_message.indexOf(' ')==-1) // if no ' ' in the message
    {
    	_keyword=_message;
    }
    else
    {
    	int indexCar=_message.indexOf(' '); // keyword is the part before ' '.
    	_keyword=_message.substring(0,indexCar);
    }
  } 
}

//-------------------------------------------------
// get()
//------------------------------------------------- 
/*
returns the keyword
*/
String SerialString::get()
{
	return _message;
}


//-------------------------------------------------
// empty()
//------------------------------------------------- 
/*
tests if the message is empty
*/
boolean SerialString::empty()
{
	if (_message.length()==0)
	{
		return true;
	}
	else
	{
		return false;
	}
}

//-------------------------------------------------
// equals()
//------------------------------------------------- 
/*
tests if the keyword is equal to str
*/

boolean SerialString::equals(String str)
{

	if (_keyword.equalsIgnoreCase(str)==true)
	{
		return true;
	}
	else
	{
		return false;
	}
}

//-------------------------------------------------
// withParameter()
//------------------------------------------------- 
/*
tests if the message has a parameter
*/

boolean SerialString::withParameter()
{
	if (_message=="")
	{
		return false;
	}
	else if (_message==_keyword)
	{
		return false;
	}
	else
	{
		return true;
	}
}


//-------------------------------------------------
// parameter()
//-------------------------------------------------
/*
returns the prameter as an integer
*/ 
int SerialString::parameter()
{
	int indexCar=_message.indexOf(' ');
	String strParam=_message.substring(indexCar);
	return strParam.toInt();
}

//-------------------------------------------------
// isSensoduino()
//-------------------------------------------------
/*
tests if the message is a sensoduino message
*/ 
boolean SerialString::isSensoduino()
{
	if (_message.charAt(0)=='>')
	{
		return true;
	}
	else
	{
		return false;
	}
}
